#INCLUDE "RWMAKE.CH"   
#include "TOTVS.CH" 
#Include "AP5Mail.ch"
#Include "topconn.ch"
#include "tbicode.ch"
#include "tbiconn.ch"      

/*


ͻ
Programa  FINP0003  Autor  Rodrigo Simes       Data   04/11/14   
͹
Desc.      Envio de email para clientes dos ttulos a vencer		  
           JOB                                                        
͹
Uso        Geraldo Secuto (Financeiro)                          	  
ͼ


*/

User Function FINP0003(aParam)

Default aParam := {"01","05"}

Private aEmp := aParam
Private lSchedule

If !Empty(funDesc())
	lSchedule := .F.
Else
	lSchedule := .T.
EndIf                  

If lSchedule
RpcSetEnv(aEmp[1],aEmp[2],"","","FIN","",{"SE1"}) //Abre os SX de acordo com a Empresa no primeiro parmetro
EndIf
  
EnviaMail()

Return

//-------------------------------
Static Function EnviaMail()
//--------------------------------

Local oHtml  
Local cCodCli
Local oMailCli
Local aEmail := {}
Local cMvHt := GetMv("MV_WFHTML")
Local nDias := 15
Private cSE1Filial	:= xFilial("SD2") // Assim, pois a SE1  compartilhada

cQuery := "SELECT E1_FILIAL, E1_PREFIXO, E1_NUM, E1_PARCELA, E1_TIPO, E1_CLIENTE, E1_LOJA, E1_EMISSAO, E1_VENCREA, "
cQuery += "A1_NOME, A1_END, A1_MUN, A1_EST, A1_CEP, A1_CGC, A1_CONTATO, A1_DDD, A1_TEL, E1_SALDO+E1_SDACRES-E1_SDDECRE E1_SALDO, E1_VALOR,E1_VEND1,A3_NOME,A3_EMAIL,A1_EMAIL "
cQuery += "FROM " + RetSqlName("SE1") + " SE1, " + RetSqlName("SA1") + " SA1 , " + RetSqlName("SA3") + " SA3 "
cQuery += "WHERE E1_CLIENTE = A1_COD "
cQuery += "AND E1_LOJA = A1_LOJA "
cQuery += "AND E1_VEND1 = A3_COD "
cQuery += "AND E1_SALDO+E1_SDACRES-E1_SDDECRE > 0 "
cQuery += "AND E1_VENCREA = '" + dtos(DDATABASE+nDias) +"'  "
cQuery += "AND E1_TIPO NOT IN ('NCC','AB-','RA') "				// Desconsidera NCC e AB- ...
cQuery += "AND SUBSTRING(SA1.A1_CGC,1,8) NOT IN ('61549812') " 	// Desconsidera Empresas do Grupo ...
cQuery += "AND E1_FILORIG = '"+cSE1Filial+"' "
cQuery += "AND E1_TIPO IN ('NF','DP') "
cQuery += "AND SE1.D_E_L_E_T_ = ' ' "
cQuery += "AND SA1.D_E_L_E_T_ = ' ' "
cQuery += "AND SA3.D_E_L_E_T_ = ' ' "
cQuery += "ORDER BY E1_VEND1,E1_CLIENTE, E1_LOJA,E1_FILIAL, E1_EMISSAO, E1_VENCREA"

cQuery := ChangeQuery(cQuery)
dbUseArea(.T.,"TOPCONN",TcGenQry(,,cQuery),"QUERY",.T.,.T.)  

//Ŀ
//Muda o parametro para enviar no corpo   
//
PutMv("MV_WFHTML","T")

dbSelectArea("QUERY")
dbGoTop()
cCodCli := ALLTRIM(QUERY->E1_CLIENTE)	
cLojaCli := ALLTRIM(QUERY->E1_CLIENTE)+ALLTRIM(QUERY->E1_LOJA) //armazena os codigos iniciais

While QUERY->(!Eof()) 
		
//FUNCOES PARA ENVIO DE HTML                         
	oProcess:=TWFProcess():New("TITVEN","Ttulos Vencidos")    
	oProcess:NewTask('titven2',"\workflow\vencido.html")	
	oHtml   := oProcess:oHtml

	oHtml:ValByName("cCliente"    ,alltrim(QUERY->A1_NOME)) //nome reduzido do cliente
	oHtml:ValByName("cVencim"     ,dtoc(stod(QUERY->E1_VENCREA))) //vencimento dos ttulos
     
    //itens da nota
	oHtml:ValByName("it.cDupli"   	, {})
	oHtml:ValByName("it.cParce"     , {})
	oHtml:ValByName("it.cEmiss"   	, {})
	oHtml:ValByName("it.cValor"     , {})
	

	lpula:= .f.	
	do while cLojacli == ALLTRIM(QUERY->E1_CLIENTE)+ALLTRIM(QUERY->E1_LOJA)
		aadd(oHtml:ValByName("it.cDupli"	 )  , QUERY->E1_NUM)
		aadd(oHtml:ValByName("it.cParce"	 ) 	, QUERY->E1_PARCELA)
		aadd(oHtml:ValByName("it.cEmiss"	 )  , dtoc(stod(QUERY->E1_EMISSAO)))
		aadd(oHtml:ValByName("it.cValor"	 )  , Transform(QUERY->E1_VALOR,"@E 99,999,999.99"))
		
		
		oMailCli:=alltrim(QUERY->A1_EMAIL)    
		QUERY->(dbskip())                  
		if cLojacli <> ALLTRIM(QUERY->E1_CLIENTE)+ALLTRIM(QUERY->E1_LOJA)
 	       Envia(oMailCli)
		   cLojaCli := ALLTRIM(QUERY->E1_CLIENTE)+ALLTRIM(QUERY->E1_LOJA)		   
		   lpula:=.t.
		   oProcess:=Nil
		   exit
		endif   
		if cCodCli <> ALLTRIM(QUERY->E1_CLIENTE)
           Envia(oMailCli)
		   cCodCli := ALLTRIM(QUERY->E1_CLIENTE)		   
		   lpula:=.t.
		   oProcess:=Nil
		   exit
		endif
    enddo
    if !lpula
       QUERY->(DBSKIP())
    endif   
End
PutMv("MV_WFHTML",cMvHt)
QUERY->(DbCloseArea())
//fecha a conexo
ConOut("Fim  : "+Time())
                       
return


Static Function Envia(oMailCli)  
Local cMail := ""


//envia o e-mail
	cUser 				:= Subs(cUsuario,7,15)
	oProcess:ClientName(cUser)
	oProcess:cTo    	:= oMailCli   
    if !empty(alltrim(cMail))
    oProcess:cCC     := alltrim(cMail)
    endif
	//oProcess:cTo    	:= "rodrigo.simoes@santino.com.br" // Usado para teste   
	subj 				:= "Relao de boletos a vencer"
	oProcess:cSubject  	:= subj                                     
	oProcess:Start()
	WFSendMail({cEmpAnt,cFilAnt})
return